''' Yet another rewrite of D&D Mod 3.5
    Begun 02/19/09
    By: Jeff Hoogland
    
    Load using:
    es_load dnds'''
import es, menulib, popuplib, os.path, cPickle, playerlib, gamethread, random, math, time


dndsinfo = es.AddonInfo()
dndsinfo.name = 'Dungeons and Dragons: Source'
dndsinfo.version = '0.6.0'
dndsinfo.url = 'http://addons.eventscripts.com/addons/view/dnds'
dndsinfo.basename = 'dnds'
dndsinfo.author = 'Jeff Hoogland'
es.ServerVar('dnd_version',dndsinfo.version,'DND By: Jeff Hoogland').makepublic()

MenuCommands = ['menu', 'help', 'modmenu', 'helpmenu', 'wodmenu', 'rpgmenu', 'changerace', 'wcsmenu', '!skills', '!spells', 'shopmenu']

#Xp For Different Things
RoundWonXp = 20
KillXp = 50
HeadShotXp = 30
KnifeXp = 90
BombXp = 40
HostageXp = 20
HolidayXp = None
HolidayReason = ''

#Delay before user's can teleport in seconds
TeleportDelay = 15

IDStorage = {}
Users = {}
Pistols = ['glock','usp','p228','deagle','fiveseven','elite']
ShotGuns = ['m3','xm1014']
SMGs = ['mac10','tmp','ump45','mp5navy','p90']
Rifles = ['galil','famas','m4a1','ak47','sg552','aug']
Snipers = ['scout','awp','sg550','g3sg1']
Grenades = ['hegrenade','flashbang','smokegrenade']
Weapons = ['ak47','m4a1','galil','famas','sg552','aug','glock','usp','p228','deagle','fiveseven','elite','m3','xm1014','mac10','tmp','ump45','mp5navy','p90','scout','awp','sg550','g3sg1','hegrenade','flashbang','smokegrenade','m249','knife']
RaceInfo = {}
ClassInfo = {}
PrestigeInfo = {}
Commands = {'lev0':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'lev1':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'lev2':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'lev3':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'tele1':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'tele2':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'save1':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'save2':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'cast':{ 'Races':[],
                    'Classes':[],
                    'Prestiges':[]},
            'freexp':{}}
XpChart = { 1:0,
            2:1000,
            3:3000,
            4:6000,
            5:10000,
            6:15000,
            7:21000,
            8:28000,
            9:36000,
            10:45000,
            11:55000,
            12:66000,
            13:78000,
            14:91000,
            15:105000,
            16:120000,
            17:136000,
            18:153000,
            19:171000,
            20:190000,
            21:210000}
TeleportAllowed = False

def load():
    global IDStorage
    str_path = es.getAddonPath('dnds') + '/IDStorage.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        IDStorage = cPickle.load(file_users)
        file_users.close()
    es.server.queuecmd('est_RegEventBlock player_spawn "es_xdoblock dnds/prepSpawn"')
    es.server.queuecmd('est_RegEventBlock player_hurt "es_xdoblock dnds/prepHurt"')
    global prestigeinfo, mainmenu, straces, laraces, monraces, classmenu, stracesinfo, classinfo, laracesinfo, monracesinfo
    mainmenu = popuplib.create('mainmenu')
    mainmenu.addline('-{ Dungeons and Dragons - CS:Source }-')
    mainmenu.addline('-> 1. Races')
    mainmenu.addline('-> 2. Classes')
    mainmenu.addline('-> 3. Prestige Classes')
    mainmenu.addline('-> 5. Mod Info')
    mainmenu.addline('-> 6. Player Info')
    mainmenu.addline('-> 7. My Stats')
    mainmenu.addline('0. Exit')
    mainmenu.submenu(1, 'racemenu')
    mainmenu.submenu(2, 'classes 1')
    mainmenu.menuselect = mainMenuSelect
    mainmenu.submenu(5, 'informationmenu')

    racemenu = popuplib.create('racemenu')
    racemenu.addline('-{ D&D CS:S - Race Menu }-')
    racemenu.addline('-> 1. Standard Races')
    racemenu.addline('-> 2. Level Adjustment Races')
    racemenu.addline('-> 3. Monster Races')
    racemenu.addline('-> 8. Back')
    racemenu.addline('0. - Exit')
    racemenu.submenu(1, 'straces 1')
    racemenu.submenu(2, 'laraces 1')
    racemenu.submenu(3, 'monraces 1')
    racemenu.submenu(8, 'mainmenu')

    informationmenu = popuplib.create('informationmenu')
    informationmenu.addline('-{ D&D CS:S - Information }-')
    informationmenu.addline('-> 1. Races')
    informationmenu.addline('-> 2. Classes')
    informationmenu.addline('-> 3. Prestige Classes')
    informationmenu.addline('-> 5. Extra Commands')
    informationmenu.addline('-> 6. When Do I Level')
    informationmenu.addline('-> 7. Credits')
    informationmenu.addline('-> 8. Back')
    informationmenu.addline('0. Exit')
    informationmenu.submenu(8, 'mainmenu')
    informationmenu.submenu(1, 'racesinfo')
    informationmenu.submenu(2, 'classinfo 1')
    informationmenu.submenu(3, 'prestigeinfo 1')
    informationmenu.submenu(5, 'extracommands')
    informationmenu.submenu(6, 'xpinfo')
    informationmenu.submenu(7, 'credits')

    extracommands = popuplib.create('extracommands')
    extracommands.addline('-{ D&D CS:S - Extra Commands }-')
    extracommands.addline(' menu - Main Menu')
    extracommands.addline(' info - Info Menu')
    extracommands.addline(' playerinfo - Player Info Menu')
    extracommands.addline(' showxp - Your Stats')
    extracommands.addline(' cast - Spell Casting Menu')
    extracommands.addline('-> 8. Back')
    extracommands.addline('0. Exit')
    extracommands.submenu(8, 'informationmenu')

    xpinfo = popuplib.create('xpinfo')
    xpinfo.addline('-{ Level: Xp Needed }-')
    xpinfo.addline(' 2:1000     - 3:3000    - 4:6000')
    xpinfo.addline(' 5:10000    - 6:15000   - 7:21000 ')
    xpinfo.addline(' 8:28000    - 9:36000   - 10:45000')
    xpinfo.addline(' 11:55000   - 12:66000  - 13:78000')
    xpinfo.addline(' 14:91000   - 15:105000 - 16:120000')
    xpinfo.addline(' 17:136000  - 18:153000 - 19:171000')
    xpinfo.addline(' 20:190000  - BP:210000 ')
    xpinfo.addline('-> 8. Back')
    xpinfo.addline('0. Exit')
    xpinfo.submenu(8, 'informationmenu')

    credits = popuplib.create('credits')
    credits.addline('-{ D&D CS:S - Credits }-')
    credits.addline(' Creator: Jeff Hoogland')
    credits.addline(' Menu Monkey/Ideas: Tony Perkins')
    credits.addline(' Based On: D&D 3.5')
    credits.addline(' Written In: Python for Eventscripts')
    credits.addline(' Where to Download:')
    credits.addline('  http://addons.eventscripts.com/addons/view/dnds')
    credits.addline(' Contacts:')
    credits.addline('  Email - Jeff@hobhq.com')
    credits.addline('  AIM/Steam - beastrace91')
    credits.addline('-> 8. Back')
    credits.addline('0. Exit')
    credits.submenu(8, 'informationmenu')
    
    prestigeinfo = menulib.create('prestigeinfo', 'informationmenu')
    prestigeinfo.settitle('-{ D&D CS:S - Prestige Info }-')

    straces = menulib.create('straces', 'racemenu', raceSelect)
    straces.settitle('-{ D&D CS:S - Races }-')

    laraces = menulib.create('laraces', 'racemenu', raceSelect)
    laraces.settitle('-{ D&D CS:S - LA Races }-')

    monraces = menulib.create('monraces', 'racemenu', raceSelect)
    monraces.settitle('-{ D&D CS:S - Monster Races }-')

    classmenu = menulib.create('classes', 'mainmenu', classSelect)
    classmenu.settitle('-{ D&D CS:S - Class Menu }-')

    raceinfo = popuplib.create('racesinfo')
    raceinfo.addline('-{ D&D CS:S - Race Info }-')
    raceinfo.addline('-> 1. Standard Races')
    raceinfo.addline('-> 2. Level Adjustment Races')
    raceinfo.addline('-> 3. Monster Races')
    raceinfo.addline('-> 8. Back')
    raceinfo.addline('0. - Exit')
    raceinfo.submenu(8, 'informationmenu')
    raceinfo.submenu(1, 'stracesinfo 1')
    raceinfo.submenu(2, 'laracesinfo 1')
    raceinfo.submenu(3, 'monracesinfo 1')

    classinfo = menulib.create('classinfo', 'informationmenu')
    classinfo.settitle('-{ D&D CS:S - Class Info}-')

    stracesinfo = menulib.create('stracesinfo', 'racesinfo')
    stracesinfo.settitle('-{ D&D CS:S - Race Info }-')

    laracesinfo = menulib.create('laracesinfo', 'racesinfo')
    laracesinfo.settitle('-{ D&D CS:S - Level Adjustment Info }-')

    monracesinfo = menulib.create('monracesinfo', 'racesinfo')
    monracesinfo.settitle('-{ D&D CS:S - Monster Info }-')

    if not es.exists('saycommand', '!menu'):
        es.regsaycmd('!menu', 'dnds/sendMain')
    if not es.exists('clientcommand', '!menu'):
        es.regclientcmd('!menu', 'dnds/sendMain')
    if not es.exists('saycommand', 'showxp'):
        es.regsaycmd('showxp', 'dnds/sendXp')
    if not es.exists('saycommand', 'playerinfo'):
        es.regsaycmd('playerinfo', 'dnds/playerInfo')
    if not es.exists('clientcommand', 'showxp'):
        es.regclientcmd('showxp', 'dnds/sendXp')
    if not es.exists('clientcommand', 'playerinfo'):
        es.regclientcmd('playerinfo', 'dnds/playerInfo')
    if not es.exists('saycommand', 'info'):
        es.regsaycmd('info', 'dnds/info')
    if not es.exists('clientcommand', 'info'):
        es.regclientcmd('info', 'dnds/info')
    if not es.exists('command', 'dnd_load'):
        es.regcmd('dnd_load', 'dnds/loadSub')
    '''if not es.exists('command', 'dnd_reload'):
        es.regcmd('dnd_reload', 'dnds/reloadSub')
    if not es.exists('command', 'dnd_unload'):
        es.regcmd('dnd_unload', 'dnds/unloadSub')'''

    for command in Commands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/%s'%command)
    for command in MenuCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/wrongMenu')
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/wrongMenu')
    es.loadevents('declare', 'addons/eventscripts/dnds/events/events.res')
    es.ServerVar('dnd_Debug').set(0)
    #Loads Defaults
    es.server.queuecmd('dnd_load Human;dnd_load Elf;dnd_load Dwarf;dnd_load Goblin;dnd_load Modron;dnd_load Kobold')
    es.server.queuecmd('dnd_load Fighter;dnd_load Rogue;dnd_load Cleric;dnd_load Wizard;dnd_load Knight;dnd_load Warlock;dnd_load Ranger')
    #Loads Level Adjustment Races
    es.server.queuecmd('dnd_load FireSouled;dnd_load Drow;dnd_load Minotaur;dnd_load ThriKreen;dnd_load Doppelganger')
    #Loads Monster Races
    es.server.queuecmd('dnd_load HalfTroll;dnd_load Tibbit;dnd_load Ethereal;dnd_load Rok;dnd_load Dragon;dnd_load Vampire')
    #Loads Prestige Classes
    es.server.queuecmd('dnd_load ExoticWeaponMaster;dnd_load GhostFaced;dnd_load AcolyteOfSkin;dnd_load Contemplative;dnd_load EldritchShadow')
    ThermalLoop()
    es.ServerVar('est_enable_PerUserKeyEvents').set('1')

def unload():
    #Loads Defaults
    es.server.queuecmd('dnd_unload Human;dnd_unload Elf;dnd_unload Dwarf;dnd_unload Goblin;dnd_unload Modron')
    es.server.queuecmd('dnd_unload Fighter;dnd_unload Rogue;dnd_unload Cleric;dnd_unload Wizard;dnd_unload Knight;dnd_unload Warlock;dnd_unload Ranger')
    #Loads Level Adjustment Races
    es.server.queuecmd('dnd_unload FireSouled;dnd_unload Drow;dnd_unload Minotaur;dnd_unload ThriKreen;dnd_unload Doppelganger')
    #Loads Monster Races
    es.server.queuecmd('dnd_unload HalfTroll;dnd_unload Tibbit;dnd_unload Ethereal;dnd_unload Rok;dnd_unload Dragon;dnd_unload Vampire')
    str_path = open(es.getAddonPath('dnds') + '/IDStorage.db', 'w')
    cPickle.dump(IDStorage, str_path)
    str_path.close()
    menulib.ClearMenus()

def deBug(msg, level):
    if level <= int(es.ServerVar('dnd_Debug')):
        es.msg(msg)

def popupSend(popupName, userid):
    count = popuplib.active(userid)['count']
    while count:
        count -= 1
        popuplib.close(popuplib.active(userid)['name'], userid)
    popuplib.find(popupName).send(userid)

def popupClose(userid):
    count = popuplib.active(userid)['count']
    while count:
        count -= 1
        popuplib.close(popuplib.active(userid)['name'], userid)

#Things sub scripts use to add to the main

def addRace(raceName, levelAdjustment=0, monsterRace=False, bpRequired=0, bonusWeapons=[], menu=True):
    if menu:
        if not levelAdjustment and not monsterRace:
            straces.addoption(raceName, raceName)
        elif not monsterRace:
            laraces.addoption(raceName, '%s (LA: %s)'%(raceName, levelAdjustment))
        else:
            monraces.addoption(raceName, '%s (BP: %s)'%(raceName, bpRequired))
    RaceInfo[raceName] = {  'la':levelAdjustment,
                            'monster':monsterRace,
                            'bp required':bpRequired,
                            'weapons':bonusWeapons}

def addRaceInformation(raceName, raceMenu, levelAdjustment=0, monsterRace=False, bpRequired=0):
    if not levelAdjustment and not monsterRace:
        stracesinfo.addsubmenu(raceMenu, raceName)
    elif not monsterRace:
        laracesinfo.addsubmenu(raceMenu, '%s (LA: %s)'%(raceName, levelAdjustment))
    else:
        monracesinfo.addsubmenu(raceMenu, '%s (BP: %s)'%(raceName, bpRequired))

def isRace(userid, raceNames):
    ID = Bank(userid)
    if ID['race']:
        if ID['race'] in raceNames:
            return True
    return False

def addClass(className, weaponsAllowed=Pistols):
    classmenu.addoption(className, className)
    ClassInfo[className] = {'weapons':weaponsAllowed}
    pmenu = menulib.create('%sprestige'%className, 'mainmenu', prestigeSelect)
    pmenu.settitle('-{ D&D CS:S - %s Prestiges }-'%className)
    pmenu = menulib.create('%sprestigeinfo'%className, 'prestigeinfo 1')
    pmenu.settitle('-{ D&D CS:S - %s Prestiges }-'%className)
    prestigeinfo.addsubmenu('%sprestigeinfo 1'%className, className)

def addClassInformation(className, classMenu):
    classinfo.addsubmenu(classMenu, className)

def isClass(userid, classNames):
    ID = Bank(userid)
    if ID['class']:
        if ID['class'] in classNames:
            return True
    return False

def addPrestigeClass(prestigeName, baseClass, levels, bonusWeapons=[]):
    PrestigeInfo[prestigeName] = {  'base class':baseClass,
                                    'levels':levels,
                                    'weapons':bonusWeapons}
    menulib.find('%sprestige'%baseClass).addoption(prestigeName, '%s (Required Level: %s)'%(prestigeName, 20-levels))

def addPrestigeInformation(prestigeName, prestigeMenu):
    menulib.find('%sprestigeinfo'%PrestigeInfo[prestigeName]['base class']).addsubmenu(prestigeMenu, prestigeName)

def isPrestige(userid, prestigeNames):
    ID = Bank(userid)
    if ID['prestige']:
        if ID['prestige'] in prestigeNames:
            return True
    return False

def isLevel(useird, clas, level):
    ID = Bank(userid)
    if clas in PrestigeInfo:
        if level <= ID[PrestigeInfo[clas]['base class']][clas]['level']:
            return True
    else:
        if level <= ID[clas]['level']:
            return True
    return False

def getLevel(userid, clas):
    ID = Bank(userid)
    if clas in PrestigeInfo:
        return ID[PrestigeInfo[clas]['base class']][clas]['level']-RaceInfo[ID['race']]['la']
    else:
        if not ID['prestige']:
            if clas not in ID:
                ID[clas] = { 'level':1,
                                    'xp':0}
            return ID[clas]['level']-RaceInfo[ID['race']]['la']
        else:
            return (20-PrestigeInfo[ID['prestige']]['levels'])
    return 0

#Events

#Gets/Sets event_var for our prep events
def ReturnEV(variable):
    """ A little wrapper to set the Event Info in a pre event to return the value  """
    es.ServerVar('wcs_temp').set(0)
    es.server.cmd('est_geteventinfo wcs_temp %s'%variable)
    try:
        return int(es.ServerVar('wcs_temp'))
    except:
        return str(es.ServerVar('wcs_temp'))
    
def SetEV(variable, value):
    """ A little wrapper to set the Event Info in a pre event to hold the value """
    es.server.cmd('est_seteventinfo %s %s'%(variable, value))

def prepSpawn():
    userid = ReturnEV('userid')
    if es.exists('userid', userid):
        ID = Bank(userid)
        Key = getPlayer(userid)
        while Key['delays'] > 0:
            #Stop all pending delays for a user that dies
            gamethread.cancelDelayed('%s_%s'%(userid, Key['delays']))
            Key['delays'] -= 1
        Default(userid)
        Key['spawn location'] = es.getplayerlocation(userid)
        #Key['damage reduction'] = 1
        #Key['dodge percent'] = 100
        #Key['dodge max damage'] = 500
        if not ID['class']:
            if not RaceInfo[ID['race']]['monster']:
                es.tell(userid, '#multi', 'You do not have a class selected... Setting to fighter')
                ID['class'] = 'Fighter'
        ID['time stamp'] = time.time()
        Class = ID['class']
        race = ID['race']
        prestige = ID['prestige']
        player = playerlib.getPlayer(userid)
        primary = player.get('primary')
        secondary = player.get('secondary')
        if primary:
            primary = primary.replace('weapon_', '')
            check = False
            if Class:
                if primary in ClassInfo[Class]['weapons']:
                    check = True
            if prestige:
                if primary in PrestigeInfo[prestige]['weapons']:
                    check = True
            if race:
                if primary in RaceInfo[race]['weapons']:
                    check = True
            if primary in Key['extra weapons']:
                check = True
            if not check:
                es.server.queuecmd('est_DropWeapon %s weapon_%s'%(userid, primary))
        if secondary:
            secondary = secondary.replace('weapon_', '')
            check = False
            if Class:
                if secondary in ClassInfo[Class]['weapons']:
                    check = True
            if prestige:
                if secondary in PrestigeInfo[prestige]['weapons']:
                    check = True
            if race:
                if secondary in RaceInfo[race]['weapons']:
                    check = True
            if secondary in Key['extra weapons']:
                check = True
            if not check:
                es.server.queuecmd('est_DropWeapon %s weapon_%s'%(userid, secondary))
    #Testing Dodge Code
   # Key['dodge percent'] = 100
   # Key['dodge max damage'] = 200

def prepHurt():
    userid = ReturnEV('userid')
    attacker = ReturnEV('attacker')
    if attacker and attacker != '0':
        damage = ReturnEV('dmg_health')
        health = es.getplayerprop(userid, 'CBasePlayer.m_iHealth')
        damage_reduction = 0
        deBug('Start Health: %s'%health, 2)
        deBug('Start Damage: %s'%damage, 2)
        #dmg_start = damage
        Key = getPlayer(userid)
        Attacker_Key = getPlayer(attacker)
        if Key['dodge percent'] >= random.randint(1, 100):
            damage_reduction += min(Key['dodge max damage'], damage)
            if (health+damage_reduction) > (damage-damage_reduction):
                es.tell(userid, '#multi', 'You have dodged and reduced the damage from an attack to %s'%(damage-damage_reduction))
        if Key['damage reduction']:
            damage_reduction += min(damage*Key['damage reduction'], damage)
        if Attacker_Key['debuff']:
            damage_reduction += min(damage*Attacker_Key['debuff'], damage)
        if damage_reduction > damage:
            damage_reduction = damage
        if (health+damage_reduction) > (damage-damage_reduction):
            SetEV('dmg_health', (damage-damage_reduction))
            SetEV('health', health+damage_reduction)
            deBug('End Damage %s'%(damage-damage_reduction),2)
            deBug('End Health %s'%str(health+(damage_reduction)),2) 
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health+damage_reduction)

def est_map_end(ev):
    """ Ran when the map ends. Delete all players if their inactivity is too high """
    time_now = time.time()
    days_till_removed = 14.0
    inactivity_length = days_till_removed * 86400
    time_now -= inactivity_length
    dellist = []
    for a in IDStorage:
        deBug('Found player %s'%a, 1)
        if 'time stamp' in IDStorage[a]:
            last_active = IDStorage[a]['time stamp']
            if time_now >= last_active:
                dellist.append(a)
        else:
            dellist.append(a)
    for player in dellist:
        deBug('Removing player %s due to in activity'%a, 1)
        del IDStorage[player]

def round_end(event_var):
    '''Fires every time a round comes to an end, this handels saving character and user infos'''
    str_path = open(es.getAddonPath('dnds') + '/IDStorage.db', 'w')
    cPickle.dump(IDStorage, str_path)
    str_path.close()
    winner = int(event_var['winner'])
    gamethread.cancelDelayed('roundend')
    for userid in es.getUseridList():
        if winner > 1:
            if es.getplayerteam(userid) == winner:
                giveXp(userid, RoundWonXp, 'winning the round')
        Key = getPlayer(userid)
        ID = Bank(userid)
        for key in ['race', 'class', 'prestige']:
           # es.msg(key)
           # es.msg(Key['delayed'][key])
            if Key['delayed'][key]:
                ID[key] = Key['delayed'][key]
                if ID[key] in ClassInfo and ID[key] not in ID:
                    ID[ID[key]] = { 'level':1,
                                    'xp':0}
                if key == 'class' and ID['prestige']:
                    if ID[key] != PrestigeInfo[ID['prestige']]['base class']:
                        ID['prestige'] = None
                if ID[key] in PrestigeInfo and ID[key] not in ID[ID['class']]:
                    ID[ID['class']][ID[key]] = {'level':0,
                                                'xp':0}
                _Check(userid)
                Key['delayed'][key] = None
                es.tell(userid, '#multi', '#defaultYou are now a %s'%ID[key])
        #Stop all pending delays linked to all players on round end
        while Key['delays'] > 0:
            gamethread.cancelDelayed('%s_%s'%(userid, Key['delays']))
            Key['delays'] -= 1
    for delay in ['teleportset']:
        gamethread.cancelDelayed(delay)

def round_start(ev):
    for userid in es.getUseridList():
        if HolidayXp:
            giveXp(userid, HolidayXp, HolidayReason)
    global TeleportAllowed
    TeleportAllowed = False
    gamethread.delayedname(TeleportDelay, 'teleportset', setTeleport)
    es.msg('#multi', '#green[Dungeons and Dragons Mod] #lightgreenType \'menu\' in chat for a game menu')

def setTeleport():
    global TeleportAllowed
    TeleportAllowed = True

def es_map_start(ev):
    es.loadevents('declare', 'addons/eventscripts/dnds/events/events.res')

def player_jump(ev):
    '''Runs every time a user jumps'''
    userid = int(ev['userid'])
    Key = getPlayer(userid)
    #Code for long jump provided by SD
    temp_multiplier = Key['jump'] - 1
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))

def item_pickup(ev):
    Key = getPlayer(ev['userid'])
    ID = Bank(ev['userid'])
    if ev['item'] in Weapons:
        Class = ID['class']
        race = ID['race']
        prestige = ID['prestige']
        check = False
        if Class:
            if ev['item'] in ClassInfo[Class]['weapons']:
                check = True
        if prestige:
            if ev['item'] in PrestigeInfo[prestige]['weapons']:
                check = True
        if race:
            if ev['item'] in RaceInfo[race]['weapons']:
                check = True
        if ev['item'] in Key['extra weapons']:
            check = True
        if not check:
            es.server.queuecmd('est_DropWeapon %s weapon_%s'%(ev['userid'], ev['item']))

def _cc_filter(userid, args):
    """ Tests to see if the user tried to buy a restricted item, if so, deny them """
    if args[0].lower() == 'buy' and len(args) > 1:
        weapon  = args[1].lower().replace('weapon_','')
        if weapon in Weapons:
            ID = Bank(userid)
            Key = getPlayer(userid)
            Class = ID['class']
            race = ID['race']
            prestige = ID['prestige']
            check = False
            if Class:
                if weapon in ClassInfo[Class]['weapons']:
                    check = True
            if prestige:
                if weapon in PrestigeInfo[prestige]['weapons']:
                    check = True
            if race:
                if weapon in RaceInfo[race]['weapons']:
                    check = True
            if weapon in Key['extra weapons']:
                check = True
            if not check:
                es.tell(userid, '#multi', 'You cannot use the %s'%weapon)
                return False
    return True
es.addons.registerClientCommandFilter(_cc_filter)

def player_death(ev):
    userid = int(ev['userid'])
    if ev['attacker']:
        attacker = int(ev['attacker'])
    else:
        attacker = 0
    Key = getPlayer(userid)
    if attacker:
        if ev['es_userteam'] != ev['es_attackerteam']:
            giveXp(attacker, KillXp, 'killing %s'%es.getplayername(userid))
            if ev['weapon'] == 'knife':
                giveXp(attacker, KnifeXp, 'a knife kill')
            if ev['headshot'] == '1':
                giveXp(attacker, HeadShotXp, 'scoring a headshot')
            AKey = getPlayer(attacker)
            AID = Bank(attacker)
            ALevel = 0
            AClass = AID['class']
            APrestige = AID['prestige']
            ALevel += RaceInfo[AID['race']]['la']
            if AClass:
                ALevel += getLevel(attacker, AClass)
                if APrestige:
                    ALevel += getLevel(attacker, APrestige)
            else:
                ALevel += min(max(RaceInfo[AID['race']]['bp required']*2, 5), 25)
            ID = Bank(userid)
            Level = 0
            Class = ID['class']
            Prestige = ID['prestige']
            Level += RaceInfo[ID['race']]['la']
            if Class:
                Level += getLevel(userid, Class)
                if Prestige:
                    Level += getLevel(userid, Prestige)
            else:
                Level += min(max(RaceInfo[ID['race']]['bp required']*2, 2), 25)
            if es.isbot(userid):
                Level = Level/2
            if Level > ALevel:
                if not es.isbot(attacker):
                    giveXp(attacker, 5*(Level-ALevel), 'killing someone who is %s levels higher than you'%(Level-ALevel))            
    Key['death location'] = es.getplayerlocation(userid)
    while Key['delays'] > 0:
        #Stop all pending delays for a user that dies
        gamethread.cancelDelayed('%s_%s'%(userid, Key['delays']))
        Key['delays'] -= 1

def player_hurt(ev):
    if ev['attacker'] and ev['attacker'] != '0' and ev['userid'] != '0':
        Key = getPlayer(ev['attacker'])
        UKey = getPlayer(ev['userid'])
        userid = int(ev['userid'])
        attacker = int(ev['attacker'])
        #es.msg('ev Damage %s'%ev['dmg_health'])
        #es.msg('ev Health %s'%ev['health'])
        if ev['dmg_health']:
            damage = int(float(ev['dmg_health']))
        else:
            damage = 0
        x1,y1,z1 = es.getplayerlocation(userid)
        x,y,z = es.getplayerlocation(attacker)
        distance = math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
        if (Key['stealth on'] and not Key['stealth delay']) or Key['Invisibility']:
            if distance < 600:
                es.event('initialize', 'sneak_attack')
                es.event('setint',     'sneak_attack', 'userid', ev['userid'])
                es.event('setint',     'sneak_attack', 'attacker', ev['attacker'])
                es.event('setint',     'sneak_attack', 'damage', ev['dmg_health'])
                es.event('fire',       'sneak_attack')
        if UKey['stealth on']:
            if distance < 600:
                if not UKey['HIPs']:
                    StealthOff(ev['userid'])
                elif UKey['HIPs'] and not random.randrange(2):
                    StealthOff(ev['userid'])
            elif distance >= 600 and distance < 840 and not random.randrange(2):
                if not UKey['HIPs']:
                    StealthOff(ev['userid'])
                elif UKey['HIPs'] and not random.randrange(2):
                    StealthOff(ev['userid'])
            elif distance >= 1100 and distance < 1340 and not random.randrange(4):
                if not UKey['HIPs']:
                    StealthOff(ev['userid'])
                elif UKey['HIPs'] and not random.randrange(2):
                    StealthOff(ev['userid'])
            elif distance >= 1600 and distance < 1840 and not random.randrange(8):
                if not UKey['HIPs']:
                    StealthOff(ev['userid'])
                elif UKey['HIPs'] and not random.randrange(2):
                    StealthOff(ev['userid'])
            elif distance >= 1840 and not random.randrange(16):
                if not UKey['HIPs']:
                    StealthOff(ev['userid'])
                elif UKey['HIPs'] and not random.randrange(2):
                    StealthOff(ev['userid'])
        if Key['stealth on']:
            if distance < 600:
                if not Key['HIPs']:
                    StealthOff(ev['attacker'])
                elif Key['HIPs'] and not random.randrange(2):
                    StealthOff(ev['attacker'])
            elif distance >= 600 and distance < 840 and not random.randrange(2):
                if not Key['HIPs']:
                    StealthOff(ev['attacker'])
                elif Key['HIPs'] and not random.randrange(2):
                    StealthOff(ev['attacker'])
            elif distance >= 1100 and distance < 1340 and not random.randrange(4):
                if not Key['HIPs']:
                    StealthOff(ev['attacker'])
                elif Key['HIPs'] and not random.randrange(2):
                    StealthOff(ev['attacker'])
            elif distance >= 1600 and distance < 1840 and not random.randrange(8):
                if not Key['HIPs']:
                    StealthOff(ev['attacker'])
                elif Key['HIPs'] and not random.randrange(2):
                    StealthOff(ev['attacker'])
            elif distance >= 1840 and not random.randrange(16):
                if not Key['HIPs']:
                    StealthOff(ev['attacker'])
                elif Key['HIPs'] and not random.randrange(2):
                    StealthOff(ev['attacker'])
        if UKey['Invisibility']:
            getPlayer(ev['userid'])['Invisibility'] = 0
            es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%ev['userid'])
            es.tell(ev['userid'], '#multi', 'You have come out of your invisibility!')
        if Key['Invisibility']:
            getPlayer(ev['attacker'])['Invisibility'] = 0
            es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%ev['attacker'])
            es.tell(ev['attacker'], '#multi', 'You have come out of your invisibility!')
        #spellDelay(userid, 1*(damage/10.0))
        StealthDelay(ev['userid'])
        StealthDelay(ev['attacker'])
        if Key['buff']:
            Damage(ev['userid'], ev['attacker'], damage*Key['buff'])

def bomb_planted(ev):
    giveXp(ev['userid'], BombXp*.75, 'planting the bomb')

def bomb_exploded(ev):
    for userid in es.getUseridList():
        if es.getplayerteam(userid) == 2:
            giveXp(userid, BombXp*.25, 'helping defend the bomb')

def bomb_defused(ev):
    giveXp(ev['userid'], BombXp*.75, 'defusing the bomb')
    for userid in es.getUseridList():
        if es.getplayerteam(userid) == 3 and int(userid) != int(ev['userid']):
            giveXp(ev['userid'], BombXp*.25, 'helping defuse the bomb')

def hostage_rescued(ev):
    giveXp(ev['userid'], HostageXp*.75, 'rescuing a hostage')

def hostage_rescued_all(ev):
    for userid in es.getUseridList():
        if es.getplayerteam(userid) == 3:
            giveXp(userid, HostageXp*.25, 'helping get all the hostages out')

def est_client_keypress(ev):
    '''Is used to track when a user presses certain keys'''
    userid = int(ev['userid'])
    Key = getPlayer(userid)
    if Key['color'] < 165:
        if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            if ev['keyname'] == 'duck' or ev['keyname'] == 'speed':
                if ev['status'] == '1':
                    Key['stealth on'] = 1
                    StealthOn(userid)
                else:
                    StealthOff(userid)
                    Key['stealth on'] = 0

#The methods that control stealth

def StealthOn(userid):
    '''Used to turn stealth on for users'''
    Key = getPlayer(userid)
    if not Key['stealth delay']:
        Color = Key['color']
        if Color < 15:
            Color = 15
        es.tell(userid, '#multi', '#lightgreenYou have gone into stealth mode.')
        es.server.queuecmd('est_setplayercolor %s 255 255 255 %s 1'%(userid, Color))

def StealthOff(userid):
    '''Used to turn stealth off for users'''
    Key = getPlayer(userid)
    if Key['stealth on']:
        if not Key['stealth delay']:
            es.tell(userid, '#multi', '#lightgreenYou have come out of your stealth.')
        es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%(userid))

def StealthDelay(userid):
    '''Used to turn stealth off for a set timer'''
    Key = getPlayer(userid)
    if Key['color'] < 165:
        Key['stealth delay'] += 1
        Delayed(userid, 5, StealthReady, userid)

def StealthReady(userid):
    '''Used to let a user restealth'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        if Key['color'] < 255:
            Key['stealth delay'] -= 1
            if not Key['stealth delay']:
                if Key['stealth on']:
                    StealthOn(userid)
                else:
                    es.tell(userid, '#multi', '#lightgreenYou are ready to go into stealth again.')

#Menu Handels
def wrongMenu():
    '''Runs when ever a user enters a menu command common for another mod'''
    userid = es.getcmduserid()
    #es.tell(userid, '#multi', '#lightgreen%s #defaultwas entered... Please use #green!menu #defaultfrom now on.'%(es.getargv(0)))
    es.cexec(userid, '!menu')

def sendMain():
    popupSend('mainmenu', es.getcmduserid())

def sendXp():
    displayPlayerInfo(es.getcmduserid(), es.getcmduserid())

def raceSelect(userid, choice, popupid):
    ID = Bank(userid)
    Key = getPlayer(userid)
    if RaceInfo[choice]['monster']:
        if RaceInfo[choice]['bp required'] > ID['bonus points']:
            es.tell(userid, '#multi', '#defaultYou need %s bonus points to play as %s'%(RaceInfo[choice]['bp required'], choice))
            return None
    Key['delayed']['race'] = choice
    es.tell(userid, '#multi', '#defaultYou will be a %s once the round ends'%choice)

def classSelect(userid, choice, popupid):
    ID = Bank(userid)
    Key = getPlayer(userid)
    Key['delayed']['class'] = choice
    Key['delayed']['prestige'] = None
    es.tell(userid, '#multi', '#defaultYou will be a %s once the round ends'%choice)

def prestigeSelect(userid, choice, popupid):
    ID = Bank(userid)
    Key = getPlayer(userid)
    check = False
    level = 0
    if not Key['delayed']['class']:
        level = ID[ID['class']]['level']
    elif Key['delayed']['class'] == PrestigeInfo[choice]['base class']:
        if Key['delayed']['class'] in ID:
            level = ID[Key['delayed']['class']]['level']
        else:
            level = 0
    if level >= (20-PrestigeInfo[choice]['levels']):
        check = True
    if check:
        Key['delayed']['prestige'] = choice
        es.tell(userid, '#multi', '#defaultYou will be a %s once the round ends'%choice)
    else:
        es.tell(userid, '#multi', 'You need to be a higher level to play as a %s'%choice)

def mainMenuSelect(userid, choice, popupid):
    ID = Bank(userid)
    Key = getPlayer(userid)
    if choice == 3:
        if not Key['delayed']['class']:
            popupSend('%sprestige 1'%ID['class'], userid)
        else:
            popupSend('%sprestige 1'%Key['delayed']['class'], userid)
    elif choice == 6:
        menulib.delete('%splayerinfo'%userid)
        playerinfo = menulib.create('%splayerinfo'%userid, 'mainmenu', playerSelect)
        playerinfo.settitle('-{ D&D CS:S - Player Info}-')
        for player in es.getUseridList():
            playerinfo.addoption(player, es.getplayername(player))
        popupSend('%splayerinfo 1'%userid, userid)
    elif choice == 7:
        displayPlayerInfo(userid, userid)

def playerInfo():
    userid = es.getcmduserid()
    popupClose(userid)
    menulib.delete('%splayerinfo'%userid)
    playerinfo = menulib.create('%splayerinfo'%userid, 'mainmenu', playerSelect)
    playerinfo.settitle('-{ D&D CS:S - Player Info}-')
    for player in es.getUseridList():
        playerinfo.addoption(player, es.getplayername(player))
    popupSend('%splayerinfo 1'%userid, userid)

def info():
    popupSend('informationmenu', es.getcmduserid())

def playerSelect(userid, choice, popupid):
    displayPlayerInfo(userid, choice)

def displayPlayerInfo(menuSend, target):
    ID = Bank(target)
    mymenu = popuplib.create('someguysinfo')
    mymenu.addline('-{ D&D CS:S - %s Info }-'%es.getplayername(target))
    Class = ID['class']
    prestige = ID['prestige']
    race = ID['race']
    if Class:
        mymenu.addline(' Race - %s'%race)
        if not prestige:
            mymenu.addline(' Class - %s (Level: %s - Xp: %s / %s)'%(Class, getLevel(target, Class), ID[Class]['xp'], XpChart[RaceInfo[race]['la']+getLevel(target, Class)+1]))
        else:
            mymenu.addline(' Class - %s (Level: %s)'%(Class, 20-PrestigeInfo[prestige]['levels']))
    else:
        mymenu.addline(' Race - %s (Xp: %s / 30000)'%(race, ID['monster xp']))
    if prestige:
        mymenu.addline(' Prestige - %s (Level: %s - Xp: %s / %s)'%(prestige, getLevel(target, prestige), XpChart[20-PrestigeInfo[prestige]['levels']]+ID[Class][prestige]['xp'], XpChart[RaceInfo[race]['la']+getLevel(target, prestige)+21-PrestigeInfo[prestige]['levels']]))
    mymenu.addline(' Bonus Points - %s'%ID['bonus points'])
    mymenu.addline('-> 8. Back')
    mymenu.addline('0. Exit')
    mymenu.submenu(8, 'mainmenu')
    popupSend('someguysinfo', menuSend)

#Used to load and unload sub scripts (races classes ect.)
def loadSub():
    es.load('dnds/SubScripts/%s'%es.getargv(1))

def unloadSub():
    es.unload('dnds/SubScripts/%s'%es.getargv(1))

def reloadSub():
    es.reload('dnds/SubScripts/%s'%es.getargv(1))

#Starting of Command Methods
def checkSpell(userid, spelllevel, amount, level, Class, ignore=[]):
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        ID = Bank(userid)
        if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            es.tell(userid, '#multi', 'You cannot cast spells while dead!')
            return False
        elif Key['spells'][spelllevel] < amount:
            if ID['class'] not in ignore:
                es.tell(userid, '#multi', 'You do not have enough of this rank spell energy left')
            return False
        elif Key['spell delay']:
            es.tell(userid, '#multi', 'It is still too soon to cast a spell')
            return False
        elif ID['class'] != Class and Class in ClassInfo:
            if ID['class'] not in ignore:
                es.tell(userid, '#multi', 'Only %s can cast that spell!'%Class)
            return False
        elif ID['prestige'] != Class and Class in PrestigeInfo:
            if ID['prestige'] not in ignore:
                es.tell(userid, '#multi', 'Only %s can cast that spell!'%Class)
            return False
        elif getLevel(userid, Class) < level:
            es.tell(userid, '#multi', 'You are not a high enough level to cast that spell')
            return False
        return True

def spellDelay(userid, delay):
    Key = getPlayer(userid)
    Key['spell delay'] += 1
    Delayed(userid, delay, spellDelayOff, (userid))
    
def spellDelayOff(userid):
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        Key['spell delay'] -= 1

def playerMenu(userid, callback, title='Playerlist', team='all', dead=0, distance=False, extra='', buff=None):
    plist = popuplib.easymenu('%s pmenu'%userid, None, callback)
    plist.settitle(title)
    x,y,z = es.getplayerlocation(userid)
    count = 0
    if team == 't' or team == 2:
        check = 2
    elif team == 'ct' or team == 'c' or team == 3:
        check = 3
    elif team == 'other':
        if es.getplayerteam(userid) == 2:
            check = 3
        elif es.getplayerteam(userid) == 3:
            check = 2
    else:
        check = 'all'
    text = ''
    add = True
    if es.getplayerprop(userid, "CBasePlayer.pl.deadflag") == dead:
        if check == 'all' or check == es.getplayerteam(userid):
            if extra == 'health':
                text = ' (%s/%s)'%(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'), getPlayer(userid)['maxhealth'])
            if extra == 'health' and es.getplayerprop(userid, 'CBasePlayer.m_iHealth') == getPlayer(userid)['maxhealth']:
                add = False
            elif buff and buff in getPlayer(userid)['buffs']:
                add = False
            if add:
                count += 1
                plist.addoption(userid, '%s%s'%(es.getplayername(userid), text))
    for player in es.getUseridList():
        text = ''
        add = True
        if player != userid:
            if es.getplayerprop(player, "CBasePlayer.pl.deadflag") == dead:
                if check == 'all' or check == es.getplayerteam(player):
                    if extra == 'health':
                        text = ' (%s/%s)'%(es.getplayerprop(player, 'CBasePlayer.m_iHealth'), getPlayer(player)['maxhealth'])
                    if buff and buff in getPlayer(player)['buffs']:
                        add = False
                    if not distance:
                        if extra == 'not undead' and getPlayer(userid)['undead']:
                            add = False
                        elif extra == 'health' and es.getplayerprop(player, 'CBasePlayer.m_iHealth') == getPlayer(player)['maxhealth']:
                            add = False
                    else:
                        if not dead:
                            x2,y2,z2 = es.getplayerlocation(player)
                        else:
                            x2,y2,z2 = getPlayer(player)['death location']
                        if math.sqrt(math.pow((x-x2), 2) + math.pow((y-y2), 2) + math.pow((z-z2), 2)) <= distance:
                            if extra == 'not undead' and getPlayer(userid)['undead']:
                                add = False
                            elif extra == 'health' and es.getplayerprop(player, 'CBasePlayer.m_iHealth') == getPlayer(player)['maxhealth']:
                                add = False
                        else:
                            add = False
                    if add:
                        count += 1
                        plist.addoption(player, '%s%s'%(es.getplayername(player), text))
    if count:
        popupSend('%s pmenu'%userid, userid)
    else:
        es.tell(userid, '#multi', 'There are no valid targets nearby!')

def giveXp(userid, amount, reason=None):
    '''Gives the given userid <amount> bonus to their current and total xp'''
    ID = Bank(userid)
    if ID['race'] == 'Human':
        amount += amount*.15
    if reason:
        es.tell(userid, '#multi', '#lightgreenXp for %s'%reason)
    Class = ID['class']
    if Class:
        if not ID['prestige']:
            ID[Class]['xp'] += amount
            es.tell(userid, '#multi', '#defaultYou have gained %s xp. (Total: %s)'%(amount, ID[Class]['xp']))
            level = ID[Class]['level']
            xpneeded = XpChart[level+1]
            if ID[Class]['xp'] >= xpneeded:
                es.emitsound('player', userid, 'ambient/energy/whiteflash.wav', '0.7', '0.5')
                if ID[Class]['level'] < 20:
                    ID[Class]['level'] += 1
                    es.tell(userid, '#multi', '#defaultYour %s has advanced to level %s'%(Class, ID[Class]['level']))
                else:
                    xpLoss = 1000*21
                    ID[Class]['xp'] -= xpLoss
                    ID['bonus points'] += 1
                    es.tell(userid, '#multi', '#defaultYou have gained a bonus points! (Total BPs: %s)'%ID['bonus points'])
        else:
            ID[Class][ID['prestige']]['xp'] += amount
            prestigeXp = XpChart[20-PrestigeInfo[ID['prestige']]['levels']]
            baseLevels = 20-PrestigeInfo[ID['prestige']]['levels']
            level = getLevel(userid, ID['prestige'])+RaceInfo[ID['race']]['la']
            xpneeded = XpChart[20-PrestigeInfo[ID['prestige']]['levels']+level+1]
            prestigeXp += ID[Class][ID['prestige']]['xp']
            es.tell(userid, '#multi', '#defaultYou have gained %s xp. (Total: %s)'%(amount, prestigeXp))
            if prestigeXp >= xpneeded:
                es.emitsound('player', userid, 'ambient/energy/whiteflash.wav', '0.7', '0.5')
                if level < PrestigeInfo[ID['prestige']]['levels']:
                    ID[Class][ID['prestige']]['level'] += 1
                    es.tell(userid, '#multi', '#defaultYour %s has advanced to level %s'%(ID['prestige'], ID[Class][ID['prestige']]['level']))
                else:
                    ID['bonus points'] += 1
                    xpLoss = 1000*21
                    ID[Class][ID['prestige']]['xp'] -= xpLoss
                    es.tell(userid, '#multi', '#defaultYou have gained a bonus points! (Total BPs: %s)'%ID['bonus points'])
    else:
        ID['monster xp'] += amount
        es.tell(userid, '#multi', '#defaultYou have gained %s xp. (Total: %s)'%(amount, ID['monster xp']))
        if ID['monster xp'] >= 30000:
            es.emitsound('player', userid, 'ambient/energy/whiteflash.wav', '0.7', '0.5')
            ID['monster xp'] -= 30000
            ID['bonus points'] += 1
            es.tell(userid, '#multi', '#defaultYou have gained a bonus points! (Total BPs: %s)'%ID['bonus points'])

def Speed(userid, amount, set=None, delay=None):
    '''A command method used to manage user's speed
    There is an issue with using just the playerprop to store the value
    so a dict is used to track each player's speed'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        if not set:
            Key['Speed'] += amount
        else:
            Key['Speed'] = amount
        es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", Key['Speed'])
        if delay:
            Delayed(userid, delay, Speed, (userid, amount*(-1)))

def Delayed(userid, duration, callback, args=()):
    '''Handels our delay calls so they cancel on user death/round end'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        Key['delays'] += 1
        gamethread.delayedname(duration, '%s_%s'%(userid, Key['delays']), callback, args)

def EndRndDelayed(duration, callback, args=()):
    gamethread.delayedname(duration, 'roundend', callback, args)

def Blind(userid, duration):
    es.setplayerprop(userid, "CCSPlayer.m_flFlashMaxAlpha", 255)
    es.setplayerprop(userid, "CCSPlayer.m_flFlashDuration", duration)

def Regeneration(userid, delay, amount, loops=None, currentloop=1):
    '''Excutes a looping heal command every X seconds'''
    if es.exists('userid', userid):
        Heal(userid, amount)
        if loops:
            if currentloop < loops:
                currentloop += 1
                Delayed(userid, delay, Regeneration, (userid, delay, amount, loops, currentloop))
        else:
            Delayed(userid, delay, Regeneration, (userid, delay, amount))

def Health(userid, amount, kind=None):
    '''Used to modify a user's max health'''
    Key = getPlayer(userid)
    if not kind:
        Key['maxhealth'] += amount
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth')+amount)
    else:
        Key['maxhealth'] = amount
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', amount)

def Heal(userid, amount, kind=None):
    '''Used to heal a user, meaning restore health up to their set max'''
    Key = getPlayer(userid)
    if Bank(userid)['race'] == 'Modron':
        amount = amount/2
    health = es.getplayerprop(userid, 'CBasePlayer.m_iHealth')
    if health+amount <= Key['maxhealth']:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health+amount)
    else:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', Key['maxhealth'])

def Gravity(userid, amount, set=False):
    '''Used to track/modify a user's current gravity level'''
    Key = getPlayer(userid)
    if not set:
        Key['gravity'] += amount
    else:
        Key['gravity'] = amount
    es.server.queuecmd('est_setgravity %s %s'%(userid, Key['gravity']))

def Freeze(userid, duration=None):
    '''Used to stop a player from moving/shooting/turning'''
    es.setplayerprop(userid, "CBasePlayer.m_fFlags", 32.0)
    if duration:
        Delayed(userid, duration, Unfreeze, userid)

def Unfreeze(userid):
    '''Restores a user's normal movement'''
    if es.exists('userid', userid):
        es.setplayerprop(userid, "CBasePlayer.m_fFlags", 1)

def TempHealth(userid, amount, timer=None):
    '''Gives said users a temporary health boost'''
    Health(userid, amount)
    if timer:
        Delayed(userid, timer, TempHealthOff, (userid,amount))

def TempHealthOff(userid, amount, timer=None):
    '''Used to end a temp health boost'''
    if es.exists('userid', userid):
        if int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) > amount:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))-amount)
        else:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 1)
        getPlayer(userid)['maxhealth'] -= amount
        if timer:
            Delayed(userid, timer, MaxHealthIncrease, (userid,amount))

def MaxHealthIncrease(userid, amount):
    if es.exists('userid', userid):
        getPlayer(userid)['maxhealth'] += amount

def Stun(userid, duration=None):
    '''Used to stop a player from walking (can still shoot ect.)'''
    es.setplayerprop(userid, "CBaseEntity.movetype", 0)
    if duration:
        Delayed(userid, duration, Unstun, (userid))

def Unstun(userid):
    '''Restores a player's normal movement'''
    if es.exists('userid', userid):
        es.setplayerprop(userid, "CBaseEntity.movetype", 2)

def Disguise(userid, delay=None):
    '''Used to make a player appear as the enemy'''
    model = None
    if es.getplayerteam(userid) == 2:
        model = random.choice(['ct_urban','ct_sas','ct_gsg9','ct_gign'])
    else:
        model = random.choice(['t_phoenix','t_leet','t_guerilla','t_arctic'])
    if model:
        es.server.queuecmd('est_SetModel %s player/%s'%(userid, model))
        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)
    if delay:
        Delayed(userid, delay, Undisguise, userid)

def Cash(userid, amount, set=False):
    if not set:
        amount = es.getplayerprop(userid,'CCSPlayer.m_iAccount') + amount
        es.setplayerprop(userid,'CCSPlayer.m_iAccount', min(amount, 16000))
    else:
        es.setplayerprop(userid,'CCSPlayer.m_iAccount', amount)

def Undisguise(userid):
    '''Used to set a player's model to their teams'''
    if es.exists('userid', userid):
        model = None
        if es.getplayerteam(userid) == 2:
            model = random.choice(['t_phoenix','t_leet','t_guerilla','t_arctic'])
        else:
            model = random.choice(['ct_urban','ct_sas','ct_gsg9','ct_gign'])
        if model:
            es.server.queuecmd('est_SetModel %s player/%s'%(userid, model))
            es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)

def Damage(userid, attacker, damage):
    '''Used to cause damage between two users
    And is safe to call in player_hurt'''
    Key = getPlayer(userid)
    damage -= min(damage*Key['damage reduction'], damage)
    if es.getplayerprop(userid, 'CBasePlayer.m_iHealth') <= damage:
        es.server.queuecmd('damage %s %s 32 %s'%(userid, damage, attacker))
    else:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth')-damage)

def Buff(userid, amount, duration=None):
    '''The value buff is linked to bonus damage user's'''
    Key = getPlayer(userid)
    Key['buff'] += amount
    if duration:
        Delayed(userid, duration, BuffOff, (userid, amount))

def BuffOff(userid, amount):
    '''Lowers the buff value, used when Buff() is called with a duration'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        Key['buff'] -= amount

def Buffs(userid, buff, timer=None):
    Key = getPlayer(userid)
    Key['buffs'].append(buff)
    if timer:
        Delayed(userid, timer, BuffsOff, (userid, buff))

def BuffsOff(userid, buff):
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        if buff in Key['buffs']:
            Key['buffs'].remove(buff)

def Debuff(userid, amount):
    '''Used to make a user cause less damage'''
    Key = getPlayer(userid)
    Key['debuff'] += amount

def Invisibility(userid, timer=None):
    Key = getPlayer(userid)
    Key['Invisibility'] = 1
    es.server.queuecmd('est_SetPlayerColor %s 255 255 255 0 1'%userid)
    if timer:
        Delayed(userid, timer, InvisibilityOff, (userid))

def InvisibilityOff(userid):
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        if Key['Invisibility']:
            Key['Invisibility'] = 0
            es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)
            es.tell(userid, '#multi', 'You are visible again!')
            if Key['stealth on'] and not Key['stealth delay']:
                StealthOn(userid)

def spellResistance(userid, level):
    Key = getPlayer(userid)
    roll = random.randrange(1,20)
    if Key['spell resistance'] < (roll+level) or roll == 1:
        return False
    return True

def tempValue(userid, key, value, timer=0):
    Key = getPlayer(userid)
    Key[key] += value
    if timer:
        Delayed(userid, timer, tempValueOff, (userid, key, value))

def tempValueOff(userid, key, value):
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        Key[key] -= value

def Fade(userid,arg1,arg2,arg3,arg4,arg5,arg6,arg7):
    '''Used to fade a user's screen a different color
    Fade <userid> <0 = no fade, 1 = fade Out 2 = fade in> <time to fade (in frames)> <time faded (in frames)> <red> <green> <blue> <alpha>'''
    if es.exists('userid',userid):
        es.usermsg('create','fade','Fade')
        es.usermsg('write','short','fade',arg2)
        es.usermsg('write','short','fade',arg3)
        es.usermsg('write','short','fade',arg1)
        es.usermsg('write','byte','fade',arg4)
        es.usermsg('write','byte','fade',arg5)
        es.usermsg('write','byte','fade',arg6)
        es.usermsg('write','byte','fade',arg7)
        es.usermsg('send','fade',userid)
        es.usermsg('delete','fade')

def HudHint(userid, msg):
    '''Displays the given message to users at the bottom of their screen'''
    es.usermsg('create','hudhint','HintText')
    es.usermsg('write','short','hudhint',-1)
    es.usermsg('write','string','hudhint',msg)
    es.usermsg('send','hudhint',userid)
    es.usermsg('delete','hudhint')

def Bank(userid):
    '''Stores the only long term information for each player, contains each person's character list based on steamid
    returns each user's long term key'''
    userid = int(userid)
    if es.exists('userid', userid):
        steamid = playerlib.uniqueid(userid)
        if steamid not in IDStorage:
            IDStorage[steamid] = {  'class':'Fighter',
                                    'race':'Human',
                                    'bonus points':0,
                                    'prestige':None,
                                    'monster xp':0,
                                    'Fighter':{ 'level':1,
                                                'xp':0}}
        return IDStorage[steamid]
    else:
        return {                    'class':None,
                                    'race':None,
                                    'bonus points':0,
                                    'prestige':None,
                                    'monster xp':0}

def Default(userid):
    '''Sets all of a user's values to defaults'''
    Key = getPlayer(userid)
    if es.exists('userid', userid):
        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)
        es.server.queuecmd('est_setgravity %s 1.0'%userid)
        Key['Speed'] = 1.0
        Key['spell resistance'] = 0
        Key['target'] = None
        Key['Sneak Dice'] = 0
        Key['HIPs'] = 0
        Key['Invisibility'] = 0
        Key['freeze'] = 0
        Key['stun'] = 0
        Key['delays'] = 0
        Key['gravity'] = 1.0
        Key['maxhealth'] = 100
        Key['jump'] = 1.0
        Key['stealth on'] = 0
        Key['stealth delay'] = 0
        Key['dodge percent'] = 0
        Key['dodge max damage'] = 0
        Key['damage reduction'] = 0.0
        Key['weapons'] = ['knife']
        Key['thermal range'] = 0
        Key['thermal invis'] = False
        Key['tele count'] = 0
        Key['color'] = 255
        Key['spawn location'] = [0,0,0]
        Key['death location'] = [0,0,0]
        Key['buff'] = 0
        Key['debuff'] = 0
        Key['buffs'] = []
        Key['trackies'] = []
        Key['extra weapons'] = []
        Key['power points'] = 0
        Key['spells'] = {   1:0,
                                                2:0,
                                                3:0}
        Key['spell delay'] = False
        ID = Bank(userid)
        if ID['race'] not in ['Zombie', 'Skeleton', 'Shadow']:
            Key['undead'] = False
            Key['delayed'] = {     'race':None,
                                                        'class':None,
                                                        'prestige':None}

def getPlayer(userid):
    '''Returns the user key of a given player, teporary storage never saved'''
    userid = int(userid)
    if es.exists('userid', userid):
        if userid not in Users:
            Users[userid] = {}
            Key = Users[userid]
            Key['Speed'] = 1.0
            Key['spell resistance'] = 0
            Key['target'] = None
            Key['Sneak Dice'] = 0
            Key['Invisibility'] = 0
            Key['freeze'] = 0
            Key['stun'] = 0
            Key['delays'] = 0
            Key['gravity'] = 1.0
            Key['maxhealth'] = 100
            Key['jump'] = 1.0
            Key['stealth on'] = 0
            Key['stealth delay'] = 0
            Key['dodge percent'] = 0
            Key['dodge max damage'] = 0
            Key['damage reduction'] = 0.0
            Key['weapons'] = ['knife']
            Key['thermal range'] = 0
            Key['thermal invis'] = False
            Key['tele count'] = 0
            Key['color'] = 255
            Key['undead'] = False
            Key['spawn location'] = [0,0,0]
            Key['death location'] = [0,0,0]
            Key['buff'] = 0
            Key['buffs'] = []
            Key['trackies'] = []
            Key['debuff'] = 0
            Key['extra weapons'] = []
            Key['spells'] = {   1:0,
                                                    2:0,
                                                    3:0}
            Key['spell delay'] = False
            Key['delayed'] = {     'race':None,
                                                        'class':None,
                                                        'prestige':None}
        return Users[userid]

#End of command Methods

#Private methods that do some interenal stuff the subscripts do not need to see
see_thru_walls_sprite = "effects/strider_bulge_dudv_dx60.vmt"
def ThermalLoop():
    for userid in es.getUseridList():
        if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            Key = getPlayer(userid)
            if Key['thermal range']:
                x,y,z = es.getplayerlocation(userid)
                for id in filter(lambda x:not x == userid and not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'), es.getUseridList()):
                    UKey = getPlayer(id)
                    if (not UKey['Invisibility'] and (not UKey['stealth on'] or UKey['stealth delay'])) or Key['thermal invis']:
                        x1, y1, z1 = es.getplayerlocation(id)
                        distance = math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
                        if distance <= Key['thermal range'] and distance >= 180:
                            alpha = 255 * (180 / distance)
                            if alpha > 255:
                                alpha = 255
                            es.server.queuecmd('est_effect %s %s %s %s %s %s %s %s %s %s'%(11, userid, 0,see_thru_walls_sprite, x1, y1, z1 + 20, .1, 1, int(alpha)))
    gamethread.delayedname(.1, 'wod_Thermal', ThermalLoop)

def _Check(userid):
    Key = getPlayer(userid)
    ID = Bank(userid)
    race = ID['race']
    if RaceInfo[race]['la']:
        if not ID['prestige']:
            if not ID['class']:
                ID['class'] = 'Fighter'
            if (ID[ID['class']]['level'] - RaceInfo[race]['la']) < 0:
                ID['race'] = 'Human'
                es.tell(userid, '#multi', '#defaultYour level adjustment is too high! Changing race to Human.')
        else:
            if (ID[ID['class']][ID['prestige']]['level'] - RaceInfo[race]['la']) < 0:
                ID['race'] = 'Human'
                es.tell(userid, '#multi', '#defaultYour level adjustment is too high! Changing race to Human.')
    elif RaceInfo[race]['monster']:
        ID['class'] = None
        ID['prestige'] = None
        Key['delayed']['class'] = None
        Key['delayed']['prestige'] = None
    elif not RaceInfo[race]['monster'] and not ID['class']:
        ID['class'] = 'Fighter'

#Client Command Methods
def CommandCheck(userid, command):
    command = command.lower()
    ID = Bank(userid)
    race = ID['race']
    clas = ID['class']
    pres = ID['prestige']
    if race in Commands[command]['Races'] or clas in Commands[command]['Classes'] or pres in Commands[command]['Prestiges']:
        return True
    es.tell(userid, '#multi', 'You cannot use the command %s'%command)
    return False

def lev0():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        Gravity(userid, 1.0, set=True)
        es.tell(userid, '#multi', 'Your gravity has been set to normal')

def lev1():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        Gravity(userid, 0.5, set=True)
        es.tell(userid, '#multi', 'Your gravity has been set to 50%')

def lev2():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        Gravity(userid, 0.2, set=True)
        es.tell(userid, '#multi', 'Your gravity has been set to 20%')

def lev3():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        Gravity(userid, .01, set=True)
        es.tell(userid, '#multi', 'Your gravity has been set to 1%')

def CheckTele(userid):
    ID = Bank(userid)
    if 'saves' not in ID:
        ID['saves'] = {}
    if str(es.ServerVar('eventscripts_currentmap')) not in ID['saves']:
        ID['saves'][str(es.ServerVar('eventscripts_currentmap'))] = {   1:None,
                                                                            2:None}

def save1():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        ID = Bank(userid)
        CheckTele(userid)
        ID['saves'][str(es.ServerVar('eventscripts_currentmap'))][1] = es.getplayerlocation(userid)
        es.tell(userid, '#multi', 'Teleport location saved')

def save2():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        ID = Bank(userid)
        CheckTele(userid)
        ID['saves'][str(es.ServerVar('eventscripts_currentmap'))][2] = es.getplayerlocation(userid)
        es.tell(userid, '#multi', 'Teleport location saved')

def tele1():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        ID = Bank(userid)
        Key = getPlayer(userid)
        CheckTele(userid)
        if TeleportAllowed:
            if Key['tele count'] > 0:
                if ID['saves'][str(es.ServerVar('eventscripts_currentmap'))][1]:
                    x, y, z = ID['saves'][str(es.ServerVar('eventscripts_currentmap'))][1]
                    es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, x, y, z))
                    Key['tele count'] -= 1
                    es.tell(userid, '#multi', 'You have teleported. %s teleports remaining'%Key['tele count'])
                else:
                    es.tell(userid, '#multi', '#defaultYou do not currently have a save1 point for %s'%es.ServerVar('eventscripts_currentmap'))
            else:
                es.tell(userid, '#multi', '#defaultYou are out of teleports for this round.')
        else:
            es.tell(userid, '#multi', '#defaultIt is still to early to teleport!')

def tele2():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        ID = Bank(userid)
        Key = getPlayer(userid)
        CheckTele(userid)
        if TeleportAllowed:
            if Key['tele count'] > 0:
                if ID['saves'][str(es.ServerVar('eventscripts_currentmap'))][2]:
                    x, y, z = ID['saves'][str(es.ServerVar('eventscripts_currentmap'))][2]
                    es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, x, y, z))
                    Key['tele count'] -= 1
                    es.tell(userid, '#multi', 'You have teleported. %s teleports remaining'%Key['tele count'])
                else:
                    es.tell(userid, '#multi', '#defaultYou do not currently have a save2 point for %s'%es.ServerVar('eventscripts_currentmap'))
            else:
                es.tell(userid, '#multi', '#defaultYou are out of teleports for this round.')
        else:
            es.tell(userid, '#multi', '#defaultIt is still to early to teleport!')

def cast():
    userid = es.getcmduserid()
    if CommandCheck(userid, es.getargv(0)):
        if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            ID = Bank(userid)
            if ID['class'] in Commands['cast']['Classes']:
                popupSend('%scast'%ID['class'], userid)
            elif ID['prestige'] in Commands['cast']['Prestiges']:
                popupSend('%scast'%ID['prestige'], userid)
            elif ID['race'] in Commands['cast']['Races']:
                popupSend('%scast'%ID['race'], userid)
        else:
            es.tell(userid, '#multi', 'You cannot cast spells while dead')

def freexp():
    giveXp(es.getcmduserid(), int(es.getargv(1)), 'testing')

#Some very basic effects
def Ring1(x,y,z, end, life, r, g, b):
    """ Normal beam effect. """
    #es.msg('ring')
    es.server.queuecmd('est_effect 10 #a 0 "sprites/lgtning.vmt" %s %s %s 1 %s %s 10 20 10 %s %s %s 255 30'%(x,y,z,end,life,r,g,b))
def Beam(player1,player2,life,r,g,b):
    #Sends a random beam connecting the two players with the given RGB color values
    choice = random.randint(1, 2)
    if choice == 1:
        Beam1(player1,player2,life,r,g,b)
    #Didnt like how this beam looks
    #elif choice == 2:
    #    Beam2(player1,player2,life,r,g,b)
    elif choice == 2:
        Beam3(player1,player2,life,r,g,b)
def Beam1(player1,player2,life,r,g,b):
    # Connects 2 users together via a normal beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    es.server.queuecmd('est_effect 3 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
def Beam2(player1,player2,life,r,g,b):
    # Connects 2 users together via a more rough beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    es.server.queuecmd('est_effect 3 #a 0 effects/tp_eyefx/tpeye3.vmt %s %s %s %s %s %s %s 7 3 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
def Beam3(player1,player2,life,r,g,b):
    # Connects 2 users together via a laser beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    es.server.queuecmd('est_effect 3 #a 0 materials/sprites/laser.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
def BeamTop(player1,life,r,g,b):
    # Connects 2 users together via a normal beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = x,y,z+180
    es.server.queuecmd('est_effect 3 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
